;
; Condition Tables
;
; Copyright 2002 by Thorsten Klose
; Commercial use without my permission is strictly forbidden!
;



;; ==========================================================================
;; get number of expected bytes depending on event type
MIDI_GetCMax
	movwf	TMP1
	swapf	TMP1, W
	andlw	0x07
	addwf	PCL, F
	retlw	0x02		; 0x8n
	retlw	0x02		; 0x9n
	retlw	0x02		; 0xan
	retlw	0x02		; 0xbn
	retlw	0x01		; 0xcn
	retlw	0x01		; 0xdn
	retlw	0x02		; 0xen
				; 0xfn
	movf	TMP1, W
	andlw	0xfe		; 0xf0 and 0xf1: expected bytes = 1
	xorlw	0xf0
	skpnz
	retlw	0x01

	movf	TMP1, W		; 0xf2:	expected bytes = 2
	xorlw	0xf2
	skpnz
	retlw	0x02

	retlw	0x00		; others: expected bytes = 0

;; ==========================================================================
;; Branch depending on Event type for 1st received byte
MIDI_LearnEvent0Branch
	swapf	MIDI_LASTEVENT0, W
	andlw	0x07
	addwf	PCL, F
	return			; don't branch on 0x8n
	return			; don't branch on 0x9n
	return			; don't branch on 0xan
	return			; don't branch on 0xbn
	return			; don't branch on 0xcn
	return			; don't branch on 0xdn
	return			; don't branch on 0xen
	clrf	MIDI_FxSTATUS	; clear FxSTATUS
	goto	PROC_ReceivedFx ; branch on 0xfx
	
;; ==========================================================================
;; Branch depending on Event type for 2nd received byte
MIDI_LearnEvent1Branch
	swapf	MIDI_LASTEVENT0, W
	andlw	0x07
	addwf	PCL, F
	return			; don't branch on 0x8n
	return			; don't branch on 0x9n
	return			; don't branch on 0xan
	return			; don't branch on 0xbn
	return			; don't branch on 0xcn  - in fact, this point will never be called
	return			; don't branch on 0xdn  - in fact, this point will never be called
	return			; don't branch on 0xen
	bsf	MIDI_FxSTATUS, 0; set FxStatus
	goto	PROC_ReceivedFx	; branch on 0xfx

;; ==========================================================================
;; Branch depending on Event type for 3rd received byte
MIDI_LearnEvent2Branch
	swapf	MIDI_LASTEVENT0, W
	andlw	0x07
	addwf	PCL, F
	goto	PROC_Received8n	; branch on 0x8n
	goto	PROC_Received9n	; branch on 0x9n
	goto	PROC_ReceivedAn	; branch on 0xan
	goto	PROC_ReceivedBn	; branch on 0xbn
	goto	PROC_ReceivedCn	; branch on 0xcn
	goto	PROC_ReceivedDn	; branch on 0xdn
	goto	PROC_ReceivedEn	; branch on 0xen
	return			; don't branch on 0xfx  - in fact, this point will never be called
